<?php
if (!defined('DC_RC_PATH')) { return; }

# Add more translations
l10n::set(dirname(__FILE__).'/locales/'.$_lang.'/public');

# Add a new class 'category-current' for the parent category
# Source: http://forum.dotclear.net/viewtopic.php?id=37514
$core->addBehavior('templateBeforeBlock',array('tabloidBehavior','block'));
$core->tpl->addValue('CategoryIfCurrent',array('tabloidTpl','CategoryIfCurrent'));

class tabloidBehavior
{
	public static function block()
	{
		$args = func_get_args();
		array_shift($args);

		if ($args[0] == 'Categories') {
			$p =
			'<?php if ($core->url->type != "home") { '.
				'if ($_ctx->exists("categories")) { '.
					'$_ctx->current_cat_id = $_ctx->categories->cat_id; '.
					'$cat_id = $_ctx->categories->cat_id; '.
					'$rs = $core->blog->getCategoryParents($cat_id); '.
					'$_ctx->current_cat_parent_id = $rs->isEmpty() ? 0 : (integer) $rs->cat_id;'.

				'} elseif ($core->url->type != "home" && $_ctx->exists("posts")) { '.
					'$_ctx->current_cat_id = $_ctx->posts->cat_id; '.
					'$cat_id = $_ctx->posts->cat_id; '.
					'$rs = $core->blog->getCategoryParents($cat_id); '.
					'$_ctx->current_cat_parent_id = $rs->isEmpty() ? 0 : (integer) $rs->cat_id;'.

				'}'.
			"} ?>\n";
			return $p;
		}
	}
}

class tabloidTpl {	
	public static function CategoryIfCurrent($attr)
	{
		$ret = isset($attr['return']) ? $attr['return'] : 'active';
		$ret = html::escapeHTML($ret);
		$p =
		'<?php if ($_ctx->exists("current_cat_id")) { '.
		'if ($_ctx->categories->cat_id == $_ctx->current_cat_id || $_ctx->categories->cat_id == $_ctx->current_cat_parent_id) { '.
			"echo ' ".addslashes($ret)." '; } ".
		'} ?>';		
		return $p;
	}
}

# Add new pagination
$core->tpl->addValue('PaginationLinks', array('tplMyPagination', 'PaginationLinks'));
class tplMyPagination {
	public static function PaginationLinks($attr)
	{
		$p = '<?php
		
		function makePageLink($pageNumber, $linkText) {
			if (isset($GLOBALS["_page_number"])) {
				$current = $GLOBALS["_page_number"];
			} else {
				$current = 1;
			}
			if ($pageNumber != $current) {
				$args = $_SERVER["URL_REQUEST_PART"];
				$args = preg_replace("#(^|/)page/([0-9]+)$#","",$args);
				$url = $GLOBALS["core"]->blog->url.$args;
				if ($pageNumber > 1) {
					$url = preg_replace("#/$#","",$url);
					$url .= "/page/".$pageNumber;
				}
				if (!empty($_GET["q"])) {
					$s = strpos($url,"?") !== false ? "&amp;" : "?";
					$url .= $s."q=".$_GET["q"];
				}
				$linkDesc = "Page &nbsp;".$linkText;
				return "<li><a href=\"".$url."\" title=\"".$linkDesc."\">".$linkText."</a></li>";
			} else {
				return "<li class=\"active\"><a>".$linkText."</a></li>";
			}
		}
		
		if (isset($GLOBALS["_page_number"])) {
			$current = $GLOBALS["_page_number"];
		} else {
			$current = 1;
		}
		if ($_ctx->exists("pagination")) {
			$nb_posts = $_ctx->pagination->f(0);
		}
		
		/* Variables to tweak the pagination system */
		$nb_per_page = $_ctx->post_params["limit"][1];
		$nb_pages = ceil($nb_posts/$nb_per_page);
		$nb_sequence = 2 * 3 + 1;
		
		?>';
		
		if (!isset($attr['max'])) { $p .= '<?php $nb_page_max = 0; ?>'; } else { $p .= '<?php $nb_page_max = '.$attr['max'].'; ?>'; }
		$p .= '<?php
		
		if ($nb_page_max == 0 || $nb_pages <= $nb_page_max) {
			for ($i = 1; $i <= $nb_pages; $i++) {
				echo makePageLink($i,$i);
			}
		} else {
			echo makePageLink(1,1);
			$min_page = max($current - ($nb_sequence - 1) / 2, 2);
			$max_page = min($current + ($nb_sequence - 1) / 2, $nb_pages - 1);
			if ($min_page > 2) { echo "<li class=\"disabled\"><a>...</a></li>"; }
			for ($i = $min_page; $i <= $max_page ; $i++) {
				echo makePageLink($i,$i);
			}
			if ($max_page < $nb_pages - 1) { echo "<li class=\"disabled\"><a>...</a></li>"; }
			echo makePageLink($nb_pages,$nb_pages);
		}
		
		?>';
		
		return $p;
	}
}

# HTML5 behaviors
$core->addBehavior('coreBlogGetPosts',array('MyHTML5ThemeBehaviors','coreBlogGetPosts'));

class MyHTML5ThemeBehaviors
{
	public static function coreBlogGetPosts($rs)
	{
		$rs->extend('rsExtHTML5ThemePosts');
	}
}

class rsExtHTML5ThemePosts extends rsExtPostPublic
{
	/**
	Returns trackback RDF information block in HTML comment.
	
	@param	rs	Invisible parameter
	@return	<b>string</b>
	*/
	public static function getTrackbackData($rs)
	{
		return
		"<!--<![CDATA[\n".
		"\n".
		'<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"'."\n".
		'  xmlns:dc="http://purl.org/dc/elements/1.1/"'."\n".
		'  xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/">'."\n".
		"<rdf:Description\n".
		'  rdf:about="'.$rs->getURL().'"'."\n".
		'  dc:identifier="'.$rs->getURL().'"'."\n".
		'  dc:title="'.htmlspecialchars($rs->post_title,ENT_COMPAT,'UTF-8').'"'."\n".
		'  trackback:ping="'.$rs->getTrackbackLink().'" />'."\n".
		"</rdf:RDF>\n".
		"]]>-->\n";
	}
}

# <tpl:IfWidget> to show/hide widgets
$core->tpl->addBlock('IfWidget',array('tplBootstrapTheme','IfWidget'));
class tplBootstrapTheme
{
	public static function IfWidget($attr,$content)
	{
		$is = isset($attr['is']) ? trim($attr['is']) : '1';
		$empty = 'YTowOnt9';
		$type = isset($attr['type']) ? trim($attr['type']) : 'custom';
		if ($is == '1') {
			switch ($type) {
				case 'nav': $p = 'if ($core->blog->settings->widgets->widgets_nav != \''.$empty.'\') {'; break;
				case 'extra': $p = 'if ($core->blog->settings->widgets->widgets_extra != \''.$empty.'\') {'; break;
				case 'custom': $p = 'if ($core->blog->settings->widgets->widgets_custom != \''.$empty.'\') {'; break;
			}
		} else {
			switch ($type) {
				case 'nav': $p = 'if ($core->blog->settings->widgets->widgets_nav === \''.$empty.'\') {'; break;
				case 'extra': $p = 'if ($core->blog->settings->widgets->widgets_extra === \''.$empty.'\') {'; break;
				case 'custom': $p = 'if ($core->blog->settings->widgets->widgets_custom === \''.$empty.'\') {'; break;
			}
		}
		return
		'<?php '.$p.' ?>'.
		$content.
		'<?php } ?>';
	}
}

?>